@use chrono_humanize::*;
@use crate::AuthorPage;
@use crate::iter::*;
@use crate::templates::author_list;
@use crate::templates::base;
@use crate::Urler;

@(url: &Urler, p: &AuthorPage)

@:base(&p.page(), {
  <header id="author">
    <div class="inner-col">
    <div class="breadcrumbs">
      <h1><a href="/">Lib.rs</a></h1> › <span class="has-keywords">@if p.is_org() {
        Orgs
      } else {
        Users
      }</span>

      <span class="keywords">
        <span>
          @for key in p.keywords.iter().take(3) {
            <a href="@url.keyword(key)" class=keyword><span>#</span>@key</a>
          }
        </span>
        @for key in p.keywords.iter().skip(3).take(3) {
          <a href="@url.keyword(key)" class=keyword><span>#</span>@key</a>
        }
      </span>

    </div>

    <h2>
      @if p.orgs.iter().any(|o| o.login == "rust-lang") {<span class=labels><span title="Member of the rust-lang org">Rust team</span></span>}
      @p.login()
    </h2>
    @if let Some(n) = p.name() {
      <p class=desc>@n</p>
    }
    <p>@if let Some(d) = p.joined {
        Joined crates-io @HumanTime::from(d).to_text_en(Accuracy::Rough, Tense::Past).
      }
      @if let Some(d) = p.joined_github() {
        Joined GitHub @HumanTime::from(d).to_text_en(Accuracy::Rough, Tense::Past).
      }
    </p>

    <nav><ul>
      <li><a rel="ugc nofollow" href="@p.github_url()">GitHub</a></li>
      <li><a rel="ugc nofollow" href="https://crates.io/users/@p.aut.github.login">crates.io</a></li>
      @if let Some((url, label)) = p.homepage_link() {
        <li><a href="@url" rel="ugc nofollow" >@label</a></li>
      }
      @if let Some((url, label)) = p.twitter_link() {
        <li><a href="@url" rel="ugc nofollow" >Twitter (@label)</a></li>
      }
      @if let Some((url, label)) = p.forum_link() {
        <li><a href="@url" rel="ugc nofollow" >Forum (@label)</a></li>
      }
    </ul></nav>
    </div>
  </header>
  <main>
    <div class="inner-col">
      @if !p.orgs.is_empty() {
        <section>
          <h3>Member of GitHub orgs</h3>
          @for (last, org) in p.orgs.iter().identify_last() {
            <a rel="ugc nofollow" href="@org.html_url">@AuthorPage::org_name(org)</a>@if !last {,}
          }
        </section>
      }
      @if !p.collab.is_empty() {
        <section>
          <h3>Collaborated with</h3>
          @for (last, user) in p.collab.iter().identify_last() {
            <a href="@url.crates_io_user_by_github_login(&user.login)">@user.login</a>@if !last {,}
          }
        </section>
      }
    </div>
    <div class="author-cols">
      <div class="inner-col">
        @if p.founder_total > 0 {
          <section>
            <h3>@p.aut.name() created @p.founder_total crate@if p.founder_total != 1 {s}</h3>
            @:author_list(&p.founder_crates, url)
          </section>
        }
        @if p.member_total > 0 {
          <section>
            <h3>Co-owns @p.member_total crate@if p.member_total != 1 {s}</h3>
            @:author_list(&p.member_crates, url)
          </section>
        }
        @if p.founder_total == 0 && p.member_total == 0 {
          <p class=empty>This person doesn't own any crates on crates-io.</p>
        }
      </div>
    </div>
  </main>
  </div>

  <footer>
    <div class="inner-col">
      <p>Based on data from crates-io, GitHub and <a href="https://rustaceans.org">rustaceans.org</a>.</p>
      <aside role="contentinfo"><p><a href="/"><b>Lib.rs</b></a> is an unofficial list of Rust/Cargo crates. It's <a href="https://gitlab.com/crates.rs?sort=stars_desc">open-source</a>, created by <a href="/~kornelski">kornelski</a>.</p></aside>
    </div>
  </footer>
})
